# LIST DESCRIPTORS

## Syntax

```sql
[ LIST | SHOW ] DESCRIPTORS
[ IN DESCRIPTOR_SOURCE descriptor_source_name ];
```

## Description

[Descriptor](https://github.com/deltastreaminc/ds-docs-gitbook/blob/main-dcap/overview/core-concepts/data-format-serde.md)[s](https://github.com/deltastreaminc/ds-docs-gitbook/blob/main-dcap/overview/core-concepts/data-format-serde.md) are used for supporting [protocol buffers](https://protobuf.dev/). Creating a descriptor source enables users to associate [ProtoBuf descriptors](https://protobuf.dev/) with specific [entities](/overview/core-concepts/store.md#entity) for data serialization and deserialization. This command provides a list of descriptors that the user has access to in the current organization. Descriptors are created when descriptor sources are created with [CREATE DESCRIPTOR\_SOURCE](/reference/sql-syntax/ddl/create-descriptor_source.md).

This command provides a list of [descriptor](/reference/sql-syntax/data-format-serialization.md)[s](/reference/sql-syntax/data-format-serialization.md), optionally filtered by a specific descriptor source.

Descriptors are listed only if the current role has `USAGE` privileges on the descriptor source.

### Arguments

#### descriptor\_source\_name

Optionally, this lists the descriptors belonging to the specified descriptor source.

## Examples

#### List all descriptors

```sh
demodb.public/demostore# LIST DESCRIPTORS;
+------------+--------------+------------+------------+-------------------------------+-------------------------------+
|  Name      |  Source Name |  Type      |  Owner     |  Created At                   |  Updated At                   |
+============+==============+============+============+===============================+===============================+
| Message2   | src1         | protobuf   | sysadmin   | 2024-06-03 16:59:52 +0000 UTC | 2024-06-03 16:59:52 +0000 UTC |
+------------+--------------+------------+------------+-------------------------------+-------------------------------+
| Message1   | src1         | protobuf   | sysadmin   | 2024-06-03 16:59:52 +0000 UTC | 2024-06-03 16:59:52 +0000 UTC |
+------------+--------------+------------+------------+-------------------------------+-------------------------------+
| StaffKey   | employee     | protobuf   | sysadmin   | 2024-06-04 19:03:51 +0000 UTC | 2024-06-04 19:03:51 +0000 UTC |
+------------+--------------+------------+------------+-------------------------------+-------------------------------+
| Manager    | employee     | protobuf   | sysadmin   | 2024-06-04 19:03:51 +0000 UTC | 2024-06-04 19:03:51 +0000 UTC |
+------------+--------------+------------+------------+-------------------------------+-------------------------------+
| Employee   | employee     | protobuf   | sysadmin   | 2024-06-04 19:03:51 +0000 UTC | 2024-06-04 19:03:51 +0000 UTC |
+------------+--------------+------------+------------+-------------------------------+-------------------------------+
| Address    | employee     | protobuf   | sysadmin   | 2024-06-04 19:03:51 +0000 UTC | 2024-06-04 19:03:51 +0000 UTC |
+------------+--------------+------------+------------+-------------------------------+-------------------------------+
```

#### List all descriptors from a descriptor source

From a list of all available descriptors, you can choose one of the descriptor source names — for example, `employee` — and list only the descriptors imported using that source:

```sh
demodb.public/demostore# LIST DESCRIPTORS IN DESCRIPTOR_SOURCE employee;
+------------+--------------+------------+------------+-------------------------------+-------------------------------+
|  Name      |  Source Name |  Type      |  Owner     |  Created At                   |  Updated At                   |
+============+==============+============+============+===============================+===============================+
| StaffKey   | employee     | protobuf   | sysadmin   | 2024-06-04 19:03:51 +0000 UTC | 2024-06-04 19:03:51 +0000 UTC |
+------------+--------------+------------+------------+-------------------------------+-------------------------------+
| Manager    | employee     | protobuf   | sysadmin   | 2024-06-04 19:03:51 +0000 UTC | 2024-06-04 19:03:51 +0000 UTC |
+------------+--------------+------------+------------+-------------------------------+-------------------------------+
| Employee   | employee     | protobuf   | sysadmin   | 2024-06-04 19:03:51 +0000 UTC | 2024-06-04 19:03:51 +0000 UTC |
+------------+--------------+------------+------------+-------------------------------+-------------------------------+
| Address    | employee     | protobuf   | sysadmin   | 2024-06-04 19:03:51 +0000 UTC | 2024-06-04 19:03:51 +0000 UTC |
+------------+--------------+------------+------------+-------------------------------+-------------------------------+
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.deltastream.io/reference/sql-syntax/command/list-descriptors.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
